
%{
exception CannotOpen of string;
%}

(* the "incl" state is used for picking up the name
 * of an include file
 *)
%x incl

%{
val include_stack = ref (nil : glex_buffer list);
fun last (a::nil) = a
  | last (_ :: rest) = last rest;
%}

%%
include             glex_begin (yyd, incl); continue

[a-z]+              #put stdout (glex_text yyd); continue
[^a-z\\n]*\n?       #put stdout (glex_text yyd); continue

<incl>[ \t]*      (* eat the whitespace *) continue
<incl>[^ \t\n]+   { (* got the include file name *)
            let val yytext = glex_text yyd
                    (* save yytext *)
            in
            include_stack := glex_current_buffer yyd
                             :: !include_stack;
            let val yyin = infile yytext
            in
               glex_switch (yyd, glex_buffer (yyd, yyin));
               glex_begin (yyd, INITIAL);
               continue
            end handle IO _ => (glex_begin (yyd, INITIAL);
                                glex_flush (yyd,
                                  glex_current_buffer yyd);
                                (case !include_stack of
                                      nil => ()
                                    | _ =>
                                      glex_switch (yyd,
                                          last (!include_stack)));
                                include_stack := nil;
                                raise CannotOpen yytext)
            end
            }

    <<EOF>> {
            case !include_stack of
                 nil => yyterminate ()
               | buf::rest =>
                 (glex_switch (yyd, buf);
                  include_stack := rest;
                  continue)
            }
