
(* scanner for a toy Pascal-like language *)

DIGIT    [0-9]
ID       [a-z][a-z0-9]*

%%

{DIGIT}+    { #put stdout "An integer: ";
              #put stdout (glex_text yyd);
	      #put stdout "\n";
              continue
                }

{DIGIT}+"."{DIGIT}*        {
              #put stdout "A float: ";
              #put stdout (glex_text yyd);
	      #put stdout "\n";
              continue
                }

if|then|begin|end|procedure|function        {
              #put stdout "A keyword: ";
              #put stdout (glex_text yyd);
	      #put stdout "\n";
              continue
                }

{ID}          #put stdout "An identifier: "; #put stdout (glex_text yyd); #put stdout "\n"; continue

"+"|"-"|"*"|"/"   #put stdout "An operator: "; #put stdout (glex_text yyd); #put stdout "\n"; continue

"{"[^}\n]*"}" (* eat up one-line comments *) continue

[ \t\n]+      (* eat up whitespace *) continue

.             #put stdout "Unrecognized character: "; #put stdout (glex_text yyd); #put stdout "\n"; continue

%%

fun tokenize filename =
    let val f = infile filename
        val yyd = glex_data (f, fn _ => true)
    in
       yylex yyd;
       #flush stdout ()
    end;
