
datatype ('a, 'ans) fiber =
	 FIBER of ('a -> 'ans) * (exn -> 'ans) -> 'ans;

datatype ('a, 'ans) cont =
	 CONT of ('a -> 'ans) * (exn -> 'ans);

    (* ret : 'a -> ('a, 'ans) fiber *)
fun ret x = FIBER (fn (cont, _) => cont x);

(* bind : ('a, 'ans) fiber -> ('a -> ('b, 'ans) fiber)
             -> ('b, 'ans) fiber *)
fun bind (FIBER fst) next =
    FIBER (fn conts as (succeed_cont, fail_cont) =>
	     fst (fn x => (* fst succeeded with result x *)
		     case next x of
			 FIBER snd => snd conts,
			 fail_cont (* fst failed *)
			 ));

(* fail : exn -> ('a, 'ans) fiber; use instead of raise *)
fun fail e =
    FIBER (fn (succeed_cont, fail_cont) => fail_cont e);

(* try : ('a, 'ans) fiber * (exn -> ('a, 'ans) fiber;
 use try (body, fn exc1 => handler1 | ...) instead
 of body handle exc1 => handler1 | ... *)
fun try (FIBER fst, handlers) =
    FIBER (fn conts as (succeed_cont, fail_cont) =>
	      fst (succeed_cont, (* fst succeeded with result x *)
		   fn exc => (* fst failed with exceptione exc *)
		      case handlers exc of
			  FIBER snd => snd conts));
	 
(* bindcc : (('a, 'ans) cont -> ('a, 'ans) fiber)
                -> ('a, 'ans) fiber *)
fun bindcc next =
    FIBER (fn conts =>
	     case next (CONT conts) of
		 FIBER snd => snd conts);

(* throw : ('a, 'ans) cont * 'a -> ('any, 'ans) fiber *)
fun throw (CONT (succeed, _), x) = FIBER (fn _ => succeed x);

(* throw_fail : ('a, 'ans) cont * exn -> ('any, 'ans) fiber *)
fun throw_fail (CONT (_, fail), x) = FIBER (fn _ => fail x);
    
(* given the body of a function : 'a -> ('b, 'ans) fiber *)
