/* Prototypes for complex arithmetic functions.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

IMPORT void InitArith P((void));

IMPORT void zpow P((EXTENDED *xx,EXTENDED *xy,EXTENDED *yx,EXTENDED *yy,
		    EXTENDED *resx,EXTENDED *resy));
IMPORT void zsqrt P((EXTENDED *xx,EXTENDED *xy,EXTENDED *xxx,EXTENDED *xyy));
IMPORT void rexp1 P((EXTENDED *x,EXTENDED *res));
IMPORT void rlog1 P((EXTENDED *x,EXTENDED *res));
IMPORT void zexp P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zexp1 P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zsin P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zcos P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void ztan P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zsh P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zch P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zth P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zatan P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zlog P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zlog1 P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zasin P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zacos P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zash P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zach P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
IMPORT void zath P((EXTENDED *x,EXTENDED *y,EXTENDED *resx,EXTENDED *resy));
