/* Prototypes for compiler to interpreted form.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

IMPORT MapPtr TyTags P((IN CONST ExprPtr table));
IMPORT MapPtr IdLocs P((IN CONST ExprPtr table));
IMPORT void InitCompile P((void));
IMPORT ExprPtr NewCompAssum P((void));

IMPORT ExprPtr cp P((IN CONST ExprPtr syntax,INOUT ExprPtr table));

IMPORT void addVal P((IN CONST ExprPtr name,IN CONST ExprPtr val,
		      IN CONST ExprPtr xcon));
#ifdef OLDDATA
IMPORT void addConstructor P((IN CONST ExprPtr tyname,IN CONST ExprPtr id,
			      IN CONST ExprPtr con,
			      IN CONST MapPtr innerkinds));
#else
IMPORT ExprPtr addConstructors P((IN CONST ExprPtr tyname,
				  IN COUNTER minmagic,
				  IN COUNTER maxmagic,...));
#endif

IMPORT ExprPtr getTopEnv P((void));
IMPORT COUNTER itIndex P((void));

IMPORT COUNTER nLocals P((IN CONST ExprPtr assum));
IMPORT void setNLocals P((IN CONST ExprPtr assum,IN COUNTER n));

IMPORT ExprPtr optPattern P((INOUT ExprPtr pat));
IMPORT ExprPtr tackPattern P((IN CONST ExprPtr pats,IN CONST ExprPtr pat,
			      IN CONST ExprPtr body,INOUT ExprPtr dbgnames,
			      INOUT INT *np));

IMPORT Boolean constantPattern P((IN CONST ExprPtr syntax,OUT ExprPtr *cstp));

IMPORT ExprPtr shiftExpr P((IN CONST ExprPtr e,IN COUNTER shift));

IMPORT INT exprSize P((IN CONST ExprPtr e,IN INT limit));
IMPORT INT funSize P((IN CONST ExprPtr e,IN INT limit));
