/* Prototypes for error signalling functions.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

IMPORT void type_warn P((IN CONST TZone *zone,IN CONST CHAR *msg));
IMPORT void type_soft_error P((IN CONST TZone *zone,IN CONST CHAR *msg));
IMPORT NORETURN void type_error P((IN CONST TZone *zone,IN CONST CHAR *msg)) _NORETURN;
IMPORT NORETURN void ml_done P((int code)) _NORETURN;
IMPORT void ml_break P((int code));
IMPORT void ml_fpe P((int code));

IMPORT NORETURN void kinderror P((IN CONST char *name,IN CHAR kind)) _NORETURN;
IMPORT NORETURN void crash_error P((IN CONST TZone *zone,IN CONST CHAR *msg)) _NORETURN;
IMPORT NORETURN ExprPtr Error P((ExprPtr exception)) _NORETURN;
IMPORT NORETURN void yy_error P((IN int l1,IN int c1,IN int l2,IN int c2,
				 IN CONST char *msg)) _NORETURN;

IMPORT void printZone P((IN CONST CHAR *filename,IN CONST TZone *zone,INOUT hFILE *out,
			 IN Boolean trailingp));
