/* Prototypes for GimML primitives.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

DECL_ACTION(mapadd)
DECL_ACTION(mapaddunder)
DECL_ACTION(add)
DECL_ACTION(sub)
DECL_ACTION(mul)
DECL_ACTION(div)
DECL_ACTION(pow)
DECL_ACTION(neg)
DECL_ACTION(sqr)
DECL_ACTION(sqrt)
DECL_ACTION(abs)
DECL_ACTION(re)
DECL_ACTION(im)
DECL_ACTION(conj)
DECL_ACTION(less)
DECL_ACTION(leq)
DECL_ACTION(greater)
DECL_ACTION(greq)
DECL_ACTION(nummin)
DECL_ACTION(nummax)
DECL_ACTION(exp)
DECL_ACTION(log)
DECL_ACTION(exp1)
DECL_ACTION(log1)
DECL_ACTION(sin)
DECL_ACTION(cos)
DECL_ACTION(tan)
DECL_ACTION(asin)
DECL_ACTION(acos)
DECL_ACTION(atan)
DECL_ACTION(sh)
DECL_ACTION(ch)
DECL_ACTION(th)
DECL_ACTION(ash)
DECL_ACTION(ach)
DECL_ACTION(ath)
DECL_ACTION(arg)
DECL_ACTION(real)
DECL_ACTION(integer)
DECL_ACTION(natural)
DECL_ACTION(floor)
DECL_ACTION(ceil)
DECL_ACTION(quotient)
DECL_ACTION(remainder)
DECL_ACTION(quotrem)
DECL_ACTION(classify)
DECL_ACTION(compose)
DECL_ACTION(inv)
DECL_ACTION(mapcompose)
DECL_ACTION(rev)
DECL_ACTION(rev1)
DECL_ACTION(append)
DECL_ACTION(concat)
DECL_ACTION(concatof)
DECL_ACTION(domrestrto)
DECL_ACTION(domrestrby)
DECL_ACTION(rngrestrto)
DECL_ACTION(rngrestrby)
DECL_ACTION(union)
DECL_ACTION(inter)
DECL_ACTION(interp)
DECL_ACTION(diff)
DECL_ACTION(delta)
DECL_ACTION(submap)
DECL_ACTION(subset)
DECL_ACTION(inset)
DECL_ACTION(inmap)
DECL_ACTION(card)
DECL_ACTION(len)
DECL_ACTION(nth)
DECL_ACTION(nthtail)
DECL_ACTION(range)
DECL_ACTION(size)
DECL_ACTION(chr)
DECL_ACTION(ord)
DECL_ACTION(ordnth)
DECL_ACTION(explode)
DECL_ACTION(substr)
DECL_ACTION(chooseindom)
DECL_ACTION(chooseinrng)
DECL_ACTION(mapremove)
DECL_ACTION(mapsplit)
DECL_ACTION(gc)
DECL_ACTION(gcfull)
DECL_ACTION(array)
DECL_ACTION(aref)
DECL_ACTION(aset)
DECL_ACTION(length)
DECL_ACTION(listarray)
DECL_ACTION(iarray)
DECL_ACTION(iaref)
DECL_ACTION(iaset)
DECL_ACTION(ilength)
DECL_ACTION(ilistarray)
DECL_ACTION(strless)
DECL_ACTION(before)
DECL_ACTION(null)
DECL_ACTION(empty)
DECL_ACTION(print)
DECL_ACTION(pretty)
DECL_ACTION(prtstdout)
DECL_ACTION(flushstdout)
DECL_ACTION(prtstderr)
DECL_ACTION(flushstderr)
DECL_ACTION(outfile)
DECL_ACTION(appendfile)
DECL_ACTION(outprocess)
DECL_ACTION(outstring)
DECL_ACTION(readstdin)
DECL_ACTION(lstdin)
DECL_ACTION(infile)
DECL_ACTION(inprocess)
DECL_ACTION(inoutprocess)
DECL_ACTION(instring)
DECL_ACTION(filebits)
DECL_ACTION(dir)
DECL_ACTION(cd)
DECL_ACTION(pwd)
DECL_ACTION(rmdir)
DECL_ACTION(mkdir)
DECL_ACTION(unlink)
DECL_ACTION(rename)
DECL_ACTION(system)
DECL_ACTION(getenv)
DECL_ACTION(errormsg)
DECL_ACTION(rrand)
DECL_ACTION(zrand)
DECL_ACTION(maybe)
DECL_ACTION(time)
DECL_ACTION(dom)
DECL_ACTION(rng)
DECL_ACTION(inds)
DECL_ACTION(elems)
DECL_ACTION(listmap)
DECL_ACTION_NORETURN(quit)
DECL_ACTION(rand)
DECL_ACTION(num)
DECL_ACTION(int)
DECL_ACTION(iabs)
DECL_ACTION(ilt)
DECL_ACTION(ile)
DECL_ACTION(igt)
DECL_ACTION(ige)
DECL_ACTION(imin)
DECL_ACTION(imax)
DECL_ACTION(idiv)
DECL_ACTION(imod)
DECL_ACTION(idivmod)
DECL_ACTION(iplus)
DECL_ACTION(iminus)
DECL_ACTION(itimes)
DECL_ACTION(ineg)
DECL_ACTION(isqr)
DECL_ACTION(ior)
DECL_ACTION(ixor)
DECL_ACTION(iand)
DECL_ACTION(inot)
DECL_ACTION(ilsl)
DECL_ACTION(ilsr)
DECL_ACTION(iasr)
DECL_ACTION(inc)
DECL_ACTION(dec)
DECL_ACTION(map)
DECL_ACTION(app)
DECL_ACTION(fold)
DECL_ACTION(revfold)
DECL_ACTION(hd)
DECL_ACTION(tl)
DECL_ACTION(denormal)
DECL_ACTION(rotten)
DECL_ACTION(system_less)
DECL_ACTION(ldexp)
DECL_ACTION(frexp)
DECL_ACTION(modf)
DECL_ACTION(getargs)
DECL_ACTION(atoi)
DECL_ACTION(atof)
DECL_ACTION(table)
DECL_ACTION(table_get)
DECL_ACTION(table_put)
DECL_ACTION(table_put_behind)
DECL_ACTION(table_remove)
DECL_ACTION(table_kill)
DECL_ACTION(table_sweep)
DECL_ACTION(table_collect)
