/* Prototypes for GimML primitives.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

DECL_ACTION_NORETURN(abort)

IMPORT void InitExec P((void));
IMPORT void InitReadline P((void));
IMPORT int StrCmp P((IN INT len1,IN CHAR *text1,
		     IN INT len2,IN CHAR *text2));
DECL_ACTION(q_mapapp)

IMPORT void addTypeAction P((IN CONST SymPtr sym,IN CONST ExprPtr type,
			     IN CONST compiledAction action));
IMPORT void addFun P((IN COUNTER n,IN CONST ExprPtr type,
		      IN CONST compiledAction action,
		      IN CONST CHAR *name));
#ifdef GIMMLX
#define ADDFUN(n,type,name) addFun(n,type,ACTION_NAME(name),(CHAR *)#name)
#else
#define ADDFUN(n,type,name) addFun(n,type,ACTION_NAME(name),NULL)
#endif
IMPORT ExprPtr addTypeRef P((IN COUNTER namei, IN COUNTER rgnnamei,
			     IN CONST ExprPtr type, IN CONST ExprPtr val));

#if TRANSLATOR
IMPORT void addBCFun P((IN COUNTER n,IN CONST ExprPtr type,
			IN CONST compiledAction action,
			IN CONST compiledAction bcaction,
			IN CONST CHAR *name));
#else
#define addBCFun(n,type,action,bcaction,name) addFun(n,type,action,name)
#endif
#ifdef GIMMLX
#define ADDBCFUN(n,type,name,bcname) addBCFun(n,type,ACTION_NAME(name),ACTION_NAME(bcname),(CHAR *)#name)
#else
#define ADDBCFUN(n,type,name,bcname) addBCFun(n,type,ACTION_NAME(name),ACTION_NAME(bcname),NULL)
#endif

IMPORT ExprPtr raiseIO P((void));
IMPORT hFILE *ffopen P((IN CONST SymPtr name,IN CONST char *mode));
