/* Prototypes for a hack to test the speed of the unshared GimML interpreter.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#if PLDI93_HACK
#define Kpair(wkind,wcar,wcdr) MakePair(wkind,wcar,wcdr)
#define Kcounted(wkind,wexpr,n) MakeCounted(wkind,wexpr,n)
#define Karray(wkind,wshape,n,wexpr) MakeRecord(wkind,wshape,n,wexpr)
#define Kint "no integers allowed in PLDI93_HACK mode"
#define KINT Kint
IMPORT ExprPtr MakeReal P((IN CONST REAL *x));
#define Kreal MakeReal
IMPORT ExprPtr MakeString1 P((IN INT len,IN CONST CHAR *text,IN Boolean copy));
#define Kstring1 MakeString1
IMPORT ExprPtr MakeStr P((IN CONST CHAR *text));
#define Kexternal MakeExternal
#define Kabs(arg,env) arg
IMPORT ExprPtr keepCons P((ExprPtr a,ExprPtr b));
#define KONS(a,b) keepCons(a,b)

IMPORT Boolean equal P((IN CONST ExprPtr x,IN CONST ExprPtr y));

#define ZZEROP(x) ((x)->kind==(CHAR)E_REAL && ZEROR(XVAL((x))))
#else
#define ZZEROP(x) ((x)==zzero)
#endif
