/* Set and map initialization.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "eval.h"
#include "expr.h"
#include "mapproto.h"
#ifdef HAS_PROTOTYPES
#include "smapinit.h"
#endif

EXTERN MapPtr mapgetCache_e,mapgetCache_m,mapgetCache_r;

PUBLIC void InitMap()
{
  EALLOC_HOMO(empty_map);
  empty_map->kind = (CHAR)E_EMPTY;
  /*empty_map->mark = (CHAR)0;*/
  CGlobals[I_EMPTY] = empty_map;
  mapgetCache_e=mapgetCache_m=mapgetCache_r=NIL;
}
