/* Definitions for homemade memory allocator.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

# define NEWPTR(size)   malloc(size)
# define DISPOSPTR(addr,size)   free(addr)

#if SPECIAL_MALLOC
typedef struct MBlock
{
  unsigned long MB_size;
  struct MBlock  *MB_next;  /* or MB_contents for allocated ptrs */
} MBlock,*MBPtr;

typedef struct MZone
{
  MBlock MZ_block;
  char *(*MZ_hook) P((unsigned long size));
} MZone,*MZPtr;

extern MZPtr theMZone;

#define MBnext(mb) ((MBPtr)(((char *)(mb)) + (mb)->MB_size))
#define MBrealsize(size) MBREALSIZE(size)

#define getMB(addr) (MBPtr)(((char *)addr)-HDSIZE)

extern char *Malloc P((unsigned long size));
     /* the general low-level allocator */
/*extern void Mfree P((char * addr));
  //  the general low-level deallocator */
extern char *Mrealloc P((char * addr,unsigned long size));
     /* the general low-level relocator */
extern MZPtr newMZone P((unsigned long size));
     /* creates mem zone */

extern MBPtr mbFreeList;
#define markFree(addr) {MBPtr mb = getMB(addr); \
	mb->MB_next = mbFreeList; mbFreeList = mb;}
extern void commitFree P((void));
#endif
