/* Additional general macros.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "system.h"

/* size of the default memory zone (currently unexpandable);
   if the memory zone cannot be created this large, it is
   created with 7/8 of the size, or (7/8)^2, (7/8)^3, ...
   of the size until we succeed in allocating it */
# define MEM_SIZE 256000000L
# define INC_SIZE 400000L

#ifndef OS_STRING
#if OS==UNIX_SYS_V
# define OS_STRING "Unix System V"
#else
#if OS==UNIX_BSD
# define OS_STRING "Unix BSD"
#else
 error "Unknown OS"
#endif
#endif
#endif

#if FLOAT_FORMAT==IEEE754
#define FLOAT_FORMAT_STRING "IEEE 754"
#else
#define FLOAT_FORMAT_STRING "unknown"
#endif
