/* Static structures for bc.c.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef void (*bindCompFun) P((IN bcFile *f,
			       IN CONST compEnv *env,
			       IN CONST ExprPtr bindings,
			       INOUT ExprPtr errp));

typedef MapPtr (*freeVarsFun) P((IN CONST ExprPtr e, INOUT compEnv *env));
typedef Boolean (*needEnvFun) P((IN CONST ExprPtr e, INOUT compEnv *env));

struct dumpletstores {
  bcFile *f;
  INT envlevel;
};

struct flushdbgnames {
  bcFile *f;
  compEnv *env;
};

struct sweepinfo {
  COUNTER listref;
  COUNTER auxref;
};
