/* Static structures for compaux.c.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef ExprPtr permutationPtr; /* list of E_VARREF, with first node
				   having CAR pointing to start of list
				   and CDR to last node of list */

struct optswp {
  union {
    COUNTER i;
    ExprPtr lbl;
  } index;
  EXTENDED w,failw;
};

struct swprec {
  ExprPtr pat;
  struct optswp *swps,*swpp;
};

struct typeweight {
  EXTENDED sumw,prodw,prodfailw;
};

struct optmapadd {
  ExprPtr xy;
  EXTENDED w,failw;
};

struct matchpatrecmapadd {
  MapPtr map2;
  permutationPtr p;
  INT *np;
};
