/* Static structures for compile.c.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct forgetlocal {
  MapPtr ids,oldids;
  COUNTER nlocals1,nlocals2;
  COUNTER level;
};

struct installshare {
  ExprPtr assum;
  ExprPtr env;
  ExprPtr binds;
};

struct cstpatrecord {
  MapPtr labpats;
  struct cpr_x { COUNTER n;
		 gcStackView *next;
		 ExprPtr p[1]; /* 1 is a dummy */
	       } cpr_x;
};

struct makerecpattern {
  ExprPtr tail;
};

struct denserec {
  INT maxn;
  INT n;
};

#ifdef OLDDATA
struct inittytag1 {
  ExprPtr assum;
  MapPtr tytagmap;
};

struct findsimpletytags {
  ExprPtr assum;
  MapPtr cons;
  COUNTER modified;
};

struct findtytaginter {
  ExprPtr con;
  ExprPtr k1;
};
#else
struct databind {
#if DEBUGGING
  ExprPtr expr,subdecl;
  MapPtr subdecls;
#endif
  ExprPtr assum;
  ExprPtr bindings;
  MapPtr tyeqs;
  Boolean sharing;
};

struct inittytag {
  ExprPtr *shape;
  INT m;
  INT p;
};
#endif

struct get_mu_data {
  TZone *z1,*z2;
  ExprPtr pat;
  ExprPtr rec;
};

struct export {
  ExprPtr assum;
  struct Basis *basis;
  ExprPtr bindings;
};
