/* Static structures for debug.c.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct snapshot {
  byteCodeChunk *bc;
  INT pc;
  ExprPtr *top;
  COUNTER stackDepth;
  COUNTER mapStackDepth;
  ExprPtr file;
  COUNTER line, pos;
  ExprPtr name;
  ExprPtr ids;
  MapPtr parent_dbgnames;
};

struct prtstrmax {
  COUNTER len,maxlen;
};

struct showargs {
  struct prtstrmax psmax;
  struct snapshot *snap;
};

struct sortinfos {
  ExprPtr code;
  ExprPtr listref;
};

struct getdz1 {
  ExprPtr code;
  SHORT cnt;
};

struct infn {
  ExprPtr polyfun;
  ExprPtr nestlist;
};

struct infn1 {
  ExprPtr polyfun;
  ExprPtr code;
  ExprPtr nestlist;
};

struct getfnname {
  ExprPtr polyfun;
  ExprPtr topenv;
  ExprPtr name;
  ExprPtr nest;
};

struct showbreak {
  INT i;
  ExprPtr msg;
};

struct possiblerefinements {
  ExprPtr strings;
  COUNTER n;
};

typedef Boolean (*sweepBreaksFun) P((IN byteCodeChunk *bc, IN OPCODE *pc, INOUT char *data));
