/* Definitions for generational gc.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

EXTERN struct Expression *writeBarrier;

#define NEWGEN ((struct Expression *)-1L)
#define OLDGEN ((struct Expression *)1L)
/* NEWGEN and OLDGEN are different from NOEXPR, since NOEXPR
   is already taken to be the end of the linked list of shared
   cons cells in hash tables. */

#define HITBARRIER(x) {if (ELINK(x)==OLDGEN) { ELINK(x)=writeBarrier;writeBarrier=(x); }}
#define SETREFVAL1(x,e) { REFVAL(x) = e; HITBARRIER(x);}
#define SETCAR1(x,e) { CAR(x) = e; HITBARRIER(x);}
#define SETCDR1(x,e) { CDR(x) = e; HITBARRIER(x);}
#define SETSHAPE1(x,e) { ASHAPE(x) = e; HITBARRIER(x);}
#define SETQENV1(x,e) { QENV(x) = e; HITBARRIER(x);}

EXTERN CHAR IncRefTable[],DecRefTable[];

#define	REFCOUNT(e) ((e)->mark & MARK_REF_COUNT)
#define	SETREFCOUNT(e,n) (e)->mark = ((e)->mark & ~MARK_REF_COUNT) | (n)

#define	INCREF(e) (e)->mark = IncRefTable[(int)(e)->mark]
#define	DECREFP(e) ((((e)->mark = DecRefTable[(int)(e)->mark]) & MARK_REF_COUNT)==0)

#define	SETQ(x,e)	{ x = e; }
#define	POPQ(x)		{ x = CDR(x); }
#define	PUSHQ(x,e,aux)	{ MAKECONS(e,x,aux); x = aux; }

#define SETREFVAL(x,e) SETREFVAL1(x,e)
#define SETCAR(x,e) SETCAR1(x,e)
#define SETCDR(x,e) SETCDR1(x,e)
#define SETSHAPE(x,e) SETSHAPE1(x,e)
#define SETQENV(x,e) SETQENV1(x,e)

#define SETMAPLETY SETCDR
