/* Static structures for print.c.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct printmapnotype {
  printFunc doprint;
  char *printdata;
  Boolean comma;
};

struct printmap {
  printFunc doprint;
  char *printdata;
  ExprPtr domtype,rngtype;
  Boolean comma;
  COUNTER lmargin,rmargin;
};

#ifdef OLDDATA
struct datacon {
  ExprPtr tag;
  ExprPtr con;
  Boolean possiblemultiple;
  Boolean multiple;
};
#endif

struct printrecord {
  printFunc doprint;
  char *printdata;
  ExprPtr type;
  Boolean comma;
  COUNTER lmargin,rmargin;
};

struct printnum {
  printFunc doprint;
  char *printdata;
  Boolean comma;
};

struct overflow {
  COUNTER lmargin,rmargin;
  stackDesc exit;
};

struct strcut {
  CHAR *text;
  INT len;
  struct overflow data;
};

struct prettymap {
  ExprPtr x,y;
  struct overflow data;
  struct printmap data2;
};

struct valprint {
  printFunc doprint;
  char *printdata;
  MapPtr locs;
};

struct typeprintmap {
  printFunc doprint;
  char *printdata;
  ExprPtr state;
  Boolean comma;
  COUNTER lmargin,rmargin;
};

struct printstring {
  COUNTER len;
  COUNTER maxlen; /* buf must contain at least maxlen+1 characters */
  CHAR *buf;
};
