/* Static structures for typeaux.c.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct newtypeinst {
  MapPtr new;
  ExprPtr assum,state;
  ExprPtr fIrename;
#if IMPERATIVE_TYPES!=EFFECT_TYVAR
  Boolean noimpp;
#endif
};

struct eqtypep {
  ExprPtr state;
  stackDesc exit;
  Boolean eqp;
};

struct imptypep {
  INT strength;
  ExprPtr state;
};

struct typemul {
  MapPtr type1,type2;
};

struct occursp {
  ExprPtr typevar;
  ExprPtr state;
};

struct typeattr {
  int new_flags;
#if IMPERATIVE_TYPES==STD_ML_NJ_TYVAR
  INT strength,maxstrength;
#endif
  ExprPtr assum;
  ExprPtr state;
  ExprPtr eqtdg;
};

struct instnumtype {
  ExprPtr state;
  MapPtr subst;
  Boolean fine;
};

struct unify_num {
  MapPtr varmap,quanmap;
  ExprPtr assum,state;
  MapPtr map1,map2;
  ExprPtr strongest;
  Boolean higherp;
};

struct find_flexappl_num {
  ExprPtr assum;
  ExprPtr state;
  ExprPtr realflex;
  ExprPtr altflex;
  Boolean altflexp;
};

struct unify_map {
  MapPtr type1,type2;
  ExprPtr assum,state;
  Boolean higherp;
};

struct cyclicfx {
  ExprPtr assum,state;
};

struct weaken {
  ExprPtr assum,state;
  INT delta;
  MapPtr *donep;
};

struct mergerecordtypes {
  TZone *zone;
  MapPtr rec2;
  ExprPtr assum;
  ExprPtr state;
};

struct typesubst {
  MapPtr new;
  MapPtr subst;
  ExprPtr assum;
  ExprPtr state;
  TZone *zone;
};

struct obsfx {
  MapPtr vars;
  ExprPtr state;
};

struct typerenamemap {
  ExprPtr info;
  ExprPtr assum;
  ExprPtr state;
};

struct pack_check {
  ExprPtr assum;
  ExprPtr state;
  ExprPtr memoref;
};

struct geteq {
  ExprPtr state;
  ExprPtr tyfcns;
  MapPtr sureeq;
  Boolean noeq;
};

struct fulleq {
  MapPtr simpleeqs;
  MapPtr subst;
};

struct checkeqcond {
  MapPtr eqs1,eqs2;
  TZone *zone;
  ExprPtr state;
};

struct checkexplicits {
  TZone *zone;
  ExprPtr assum;
  ExprPtr state;
  MapPtr values;
  ExprPtr wrong;
};

struct tyvars {
  ExprPtr assum,state;
  SHORT flags;
#if IMPERATIVE_TYPES==STD_ML_NJ_TYVAR
  INT strength;
#endif
  ExprPtr memoref;
};

struct unquant {
  ExprPtr assum,state;
  ExprPtr memoref;
};

struct setstrengths {
  ExprPtr state;
  ExprPtr strength;
};

struct checkstrengths {
  TZone *zone;
  ExprPtr state;
};

struct instscale {
  ExprPtr coeff;
  MapPtr var;
  ExprPtr state;
};

struct unifyscale {
  ExprPtr constmap,varmap;
  MapPtr map1,map2;
  ExprPtr assum;
};
