/* Definitions for allocation functions in shared tables.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Bison; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define RequireOneCell()  \
	CHECKHOMOFREE()

#define RequireOneHeteroCell() \
        CHECKHETEROFREE()

#define RequireOneHomoCellAndOneSlot() \
	if (theAvailSlotList==reserveSlot) \
	  theSlotBucketList = NewSlotBucket(newptr_gc); \
	CHECKHOMOFREE()

#define RequireOneHeteroCellAndOneSlot() \
	if (theAvailSlotList==reserveSlot) \
	  theSlotBucketList = NewSlotBucket(newptr_gc); \
	CHECKHETEROFREE()

#define RequireTwoSlots() \
	if (theAvailSlotList==reserveSlot || NEXTFREE(theAvailSlotList)==reserveSlot) \
	  theSlotBucketList = NewSlotBucket(newptr_gc)
