/* Test whether we have BSD-style directory handling functions.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>

extern int strcmp(const char *s, const char *t);

int main()
{
  DIR *dirp;
  struct dirent *dp;

  dirp=opendir(".");
  while ((dp=readdir(dirp))!=NULL)
    if(strcmp(dp->d_name, "test")==0)
      {
	closedir(dirp);
	return 1;
      }
  closedir(dirp);
  return 0;
}
