/* Tests for <varargs.h> style of varargs.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <varargs.h>

extern void abort (void);

/* taken from the Unix man pages */

/*VARARGS*/
void
error(va_alist)
     /* Note that the function_name and format arguments cannot be
      *    separately declared because of the definition of varargs.  */
     va_dcl
{
  va_list args;
  char *fmt;
  
  va_start(args);
  /* print out name of function causing error */
  (void)fprintf(stderr, "ERROR in %s: ", va_arg(args, char *));
  fmt = va_arg(args, char *);
  /* print out remainder of message */
  (void)vfprintf(stderr, fmt, args);
  va_end(args);
  (void)abort( );
}
