/* Prototypes for type checking functions.
   Copyright (C) 2021 Jean Goubault-Larrecq
   and Université Paris-Saclay, CNRS, ENS Paris-Saclay,
   Laboratoire Méthodes Formelles, 91190, Gif-sur-Yvette, France.

   This file is part of GimML.

   GimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   GimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

IMPORT MapPtr IdTypes P((IN CONST ExprPtr assum));
IMPORT MapPtr STyCons P((IN CONST ExprPtr state));
IMPORT ExprPtr ApplyType P((IN CONST ExprPtr type,
			    IN CONST ExprPtr tyhdr,
			    IN CONST ExprPtr argtypes,
			    IN CONST ExprPtr assum,
			    IN CONST ExprPtr state));
IMPORT void addIdTypes P((IN CONST ExprPtr id,IN CONST ExprPtr type,INOUT ExprPtr assum));
IMPORT void addConsTypes P((IN CONST ExprPtr id,IN CONST ExprPtr type,INOUT ExprPtr assum));
IMPORT void remConsTypes P((IN CONST ExprPtr id,INOUT ExprPtr assum));
IMPORT void addIdType P((IN CONST ExprPtr name,IN CONST ExprPtr type));
IMPORT void addIdLocs P((IN CONST ExprPtr id,IN CONST ExprPtr type,INOUT ExprPtr assum));
IMPORT void addDataType P((IN CONST ExprPtr name,IN CONST ExprPtr tyvarseq,
			   IN CONST ExprPtr type,IN CONST ExprPtr cons));

IMPORT ExprPtr correctTypeAppl P((IN CONST ExprPtr type,
				  IN CONST ExprPtr state));
IMPORT void InitTypes P((void));

#if IMPERATIVE_TYPES==EFFECT_TYVAR
IMPORT ExprPtr varType P((ExprPtr var,ExprPtr assum,ExprPtr state));
#else
IMPORT ExprPtr varType P((ExprPtr var,ExprPtr assum,ExprPtr state,Boolean noimpp));
#endif
IMPORT Boolean coerceTypes P((TZone *zone,ExprPtr type1,ExprPtr type2,
			      ExprPtr assum,ExprPtr state,Boolean higherp));
IMPORT Boolean coerceTypesImport P((TZone *zone,ExprPtr type1,ExprPtr type2,
				    ExprPtr assum,ExprPtr state,
				    ExprPtr var,Boolean higherp));
IMPORT Boolean TypeMatch P((IN CONST MapPtr pat,IN CONST MapPtr type));
IMPORT ExprPtr tcDeclaration P((IN CONST ExprPtr syntax,
				IN CONST ExprPtr assum,
				INOUT ExprPtr state));
